/*  ʵ(EUC)Ա ؼ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "critical_section.h"

namespace euc
{

critical_section::critical_section(void)
{
#if defined(UNIX) || defined(LINUX)
    _cs = new pthread_mutex_t;
    pthread_mutex_init(_cs, NULL);
    _owner = (pthread_t) -1;
    _lock_count = 0;
#else
    InitializeCriticalSection(&_cs);
#endif
}

critical_section::~critical_section(void)
{
#if defined(UNIX) || defined(LINUX)
    delete _cs;
#else
    DeleteCriticalSection(&_cs);
#endif
}

// סö
bool critical_section::lock(bool block)
{
#if defined(UNIX) || defined(LINUX)
    // Windows µ CRITICAL_SECTION Աһ̶߳ظס
    //  Linux/UNIX Ҫͨ
    pthread_t current = pthread_self();
    if (current == _owner)
    {
        ++_lock_count;
        return true;
    }

    if (!block)
    {
        bool result = pthread_mutex_trylock(_cs) == 0;
        if (result)
            ++_lock_count;
        return result;
    }

    pthread_mutex_lock(_cs);
    ++_lock_count;
    _owner = current;
#else
    EnterCriticalSection(&_cs);
#endif
    return true;
}

// ö
void critical_section::unlock(void)
{
#if defined(UNIX) || defined(LINUX)
    // Windows µ CRITICAL_SECTION Աһ̶߳ظס
    //  Linux/UNIX Ҫͨ
    _owner = (pthread_t) -1;
    if (--_lock_count == 0)
        pthread_mutex_unlock(_cs);
#else
    LeaveCriticalSection(&_cs);
#endif
}

}; // namespace
