On Error Resume Next

Set WshShell = CreateObject("WScript.Shell")

sSelfPath = WScript.ScriptFullName
sSelfPath = Left(sSelfPath, InStrRev(sSelfPath, "\") - 1)

Set Fso = CreateObject("Scripting.FileSystemObject")

Set File = Fso.OpenTextFile("PROJECT")
If Err <> 0 Then WScript.Quit 1

bInTrasferBlock = False
bInBuildBlock = False

For Each line In Split(File.ReadAll, vbNewLine)
    line = Trim(line)
    ' ųкע
    If line <> "" And Left(line, 1) <> ";" Then
        '  [] 
        If bInTransferBlock Or bInBuildBlock Then
            If Left(line, 1) = "[" And Right(line, 1) = "]" Then
                bInBuildBlock = (LCase(Line) = "[build]")
                bInTransferBlock = (LCase(Line) = "[transfer]")
            End if

            ' ȡȺߺұߵ
            statement = Split(line, "=", 2)
            key = Trim(statement(0))
            If UBound(statement) > 0 Then
                value = Trim(statement(1))
            Else
                value = ""
            End if

            If LCase(key) = "protocol" Then
                If bInBuildBlock Then
                    sBuildProtocol = value
                End if
                If bInTransferBlock Then
                    sTransferProtocol = value
                End if
            End if
        Else
            bInBuildBlock = (LCase(Line) = "[build]")
            bInTransferBlock = (LCase(Line) = "[transfer]")
        End if
    End if
Next

If Not Fso.FileExists(sSelfPath & "\transfer\" & sTransferProtocol _
    & ".vbs") Then
    WScript.StdOut.WriteLine "PROJECT: Unknown protocol"
    WScript.Quit 1
End if

If Not Fso.FileExists(sSelfPath & "\build\" & sBuildProtocol & ".vbs") Then
    WScript.StdOut.WriteLine "PROJECT: Unknown protocol"
    WScript.Quit 1
End if

Set oExec = WshShell.Exec("cscript.exe /nologo """ _
    & sSelfPath & "\transfer\" & sTransferProtocol & ".vbs""")

While Not oExec.StdOut.AtEndOfStream
    Line = oExec.StdOut.ReadLine
    WScript.StdOut.WriteLine Line
Wend

ExitCode = oExec.ExitCode
If ExitCode <> 0 Then
    WScript.Quit ExitCode
End if

Set oExec = Nothing

' ȡв
Set objArgs = WScript.Arguments
For i = 1 to objArgs.Count
    sArgs = sArgs & " " & objArgs(i - 1)
Next

If Len(sArgs) = 0 Then
    Set oExec = WshShell.Exec("cscript.exe /nologo """ _
        & sSelfPath & "\build\" & sBuildProtocol & ".vbs""")
Else
    Set oExec = WshShell.Exec("cscript.exe /nologo """ _
        & sSelfPath & "\build\" & sBuildProtocol & ".vbs"" " & sArgs)
End if

While Not oExec.StdOut.AtEndOfStream
    Line = oExec.StdOut.ReadLine
    WScript.StdOut.WriteLine Line
Wend

ExitCode = oExec.ExitCode
Set oExec = Nothing

Set Fso = Nothing
Set WshShell = Nothing

WScript.Quit ExitCode
