#ifndef _SNAILCLASSFACTORY_APPEARED_
#define _SNAILCLASSFACTORY_APPEARED_

#include <windows.h>

class SnailClassFactory : public IClassFactory
{
public:
    SnailClassFactory(void);
    ~SnailClassFactory(void);

public:
    //IUnknown members
    STDMETHODIMP QueryInterface(REFIID iid, LPVOID FAR *inter);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    //IClassFactory members
    STDMETHODIMP CreateInstance(LPUNKNOWN outter, REFIID, LPVOID FAR *object);
    STDMETHODIMP LockServer(BOOL lock);

public:
    static bool CanUnloadNow(void);

private:
    ULONG _ref_counter;

private:
    static ULONG _global_ref_counter;
};

#endif // _SNAILCLASSFACTORY_APPEARED_
