// Last Modified: 2005-08-10 16:39:32
#include <list>
#include <string>

#define TAB_STOP 4

// 截取字符串两端的空格和 tab，返回字符串前端的白空格长度。
// buffer 不可以指向只读内存区域。
int trim(char *buffer, int tab_stop = TAB_STOP);

// 根据全路径获取文件名
std::string getfilename(std::string fullpath);

// 根据全路径获取文件所在路径，返回值包含最右端的路径分隔符
std::string getpathname(std::string fullpath);

// 将 str 按指定的字符打碎。
std::list<std::string> split(std::string str,
    const char *const splitter = " ");

// 化简目录
std::string path_simplify(std::string curpath, std::string path,
    std::string _platform);
