/*  ʵ(EUC)Ա ַغ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "stringutil.h"

namespace euc
{

// ȥַ˵ַָ
std::string ltrim(std::string text, const char totrim)
{
    std::string::size_type first = text.find_first_not_of(totrim);
    if (first == std::string::npos)
        return "";
    else
        return text.substr(first);
}

// ȥַҶ˵ַָ
std::string rtrim(std::string text, const char totrim)
{
    std::string::size_type last = text.find_last_not_of(totrim);
    if (last == std::string::npos)
        return "";
    else
        return text.substr(0, last + 1);
}

// ȥַ˵ַָ
std::string trim(std::string text, const char totrim)
{
    std::string::size_type first = text.find_first_not_of(totrim);
    std::string::size_type last = text.find_last_not_of(totrim);

    if (first == std::string::npos && last == std::string::npos)
        return "";
    else
        return text.substr(first, last - first + 1);
}

// ȥַ˵ַָ
std::string ltrim(const char *const text, const char totrim)
{
    std::string passer = text;
    return ltrim(passer, totrim);
}

// ȥַҶ˵ַָ
std::string rtrim(const char *const text, const char totrim)
{
    std::string passer = text;
    return rtrim(passer, totrim);
}

// ȥַ˵ַָ
std::string trim(const char *const text, const char totrim)
{
    std::string passer = text;
    return trim(passer, totrim);
}

// һַ
std::string sequence(const char elem,
                     std::string::size_type size)
{
    std::string result;
    result.resize(size);
    std::fill(result.begin(), result.end(), elem);
    return result;
}

// һַظɱ
std::string sequence(std::string elem, std::string::size_type size)
{
    std::string result;
    result.resize(size * elem.size());

    for (std::string::size_type i = 0; i < size; ++i)
    {
        for (std::string::size_type j = 0; j < elem.size(); ++j)
            result[i * elem.size() + j] = elem[j];
    }

    return result;
}

// һַתΪд
std::string to_upper(std::string text)
{
    std::string result;
    std::string::size_type size;
    result.resize(size = text.size());

    for (std::string::size_type i = 0; i < size; ++i)
    {
        result[i] = text[i] >= 'a' && text[i] <= 'z' ?
            text[i] - ('a' - 'A') : text[i];
    }

    return result;
}

// һַתΪСд
std::string to_lower(std::string text)
{
    std::string result;
    std::string::size_type size;
    result.resize(size = text.size());

    for (std::string::size_type i = 0; i < size; ++i)
    {
        result[i] = text[i] >= 'A' && text[i] <= 'Z' ?
            text[i] + ('a' - 'A') : text[i];
    }

    return result;
}

// һַתΪд
std::string to_upper(const char *const text)
{
    std::string passer = text;
    return to_upper(passer);
}

// һַתΪСд
std::string to_lower(const char *const text)
{
    std::string passer = text;
    return to_lower(passer);
}

// ַ滻
std::string replace_all(std::string source, const char change,
                        const char to)
{
    for (std::string::size_type i = 0; i < source.size(); ++i)
        if (source[i] == change)
            source[i] = to;
    return source;
}

// ַ滻
std::string replace_all(const char *const source,
                        const char change, const char to)
{
    return replace_all(std::string(source), change, to);
}

// ַ滻
std::string replace_all(std::string source, std::string change,
                        std::string to)
{
    std::string result;

    std::string::size_type pos = 0;
    std::string::size_type check = 0;
    while ((check = source.find(change, pos)) != std::string::npos)
    {
        result += source.substr(pos, check - pos);
        result += to;
        pos = check + change.size();
    }

    result += source.substr(pos);
    return result;
}

// ַ滻
std::string replace_all(const char *const source,
                        const char *const change, const char *const to)
{
    return replace_all(std::string(source),
        std::string(change), std::string(to));
}

//  str2 Ƿ str1 ǰ׺
bool start_with(const char *const str1, const char *const str2)
{
    char *param1 = (char *) str1;
    char *param2 = (char *) str2;
    while (*param2 && *param1 == *param2)
    {
        ++param1;
        ++param2;
    }

    return *param2 == 0;
}

//  str2 Ƿ str1 ǰ׺
bool start_with(const std::string &str1, const std::string &str2)
{
    if (str2.size() > str1.size())
        return false;

    for (std::string::size_type pos = 0; pos != str2.size(); ++pos)
        if (str1[pos] != str2[pos])
            return false;

    return true;
}

//  str2 Ƿ str1 ĺ׺
bool end_with(const std::string &str1, const std::string &str2)
{
    std::string::difference_type delta;
    if ((delta = str1.size() - str2.size()) < 0)
        return false;

    for (std::string::size_type pos = 0; pos != str2.size(); ++pos)
        if (str1[pos + delta] != str2[pos])
            return false;

    return true;
}

//  str2 Ƿ str1 ĺ׺
bool end_with(const char *const str1, const char *const str2)
{
    size_t size1, size2;
    int delta;
    if ((delta = (int) ((size1 = strlen(str1))
        - (size2 = strlen(str2)))) < 0)
        return false;

    for (size_t pos = 0; pos < size2; ++pos)
        if (str1[pos + delta] != str2[pos])
            return false;

    return true;
}

} // namespace
